SystemOrganization addCategory: #'Magma seaside'!

WASystemConfiguration subclass: #WAMagmaConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:27'!
ancestors

	^ Array with: (WARenderLoopConfiguration localConfiguration)! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:17'!
attributes
    "Return the attributes specific to this configuration"

	^ Array with: (WAMagmaLocationAttribute key: #location group: #magma)
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 11:44'!
location

	^ MagmaLocalLocation default
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:35'!
repositoryPath

	^ 'store'
! !

!WAMagmaConfiguration methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 11:24'!
sessionClass

	^ WAMagmaSession! !

WASession subclass: #WAMagmaSession
	instanceVariableNames: 'magmaSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:53'!
commit: aBlock

	self magmaSession commit: aBlock
! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:58'!
expire

	super expire.
	magmaSession ifNotNil: [ magmaSession disconnect. magmaSession := nil ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:19'!
magmaSession

	^ magmaSession ifNil: [ 
		magmaSession := (self application preferenceAt: #location) newSession.
		magmaSession connectAs: 'seaside'.
		magmaSession ]! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:56'!
repositoryPath
	"This is a convenience method to get the repository directory path from Seaside"

	^ FileDirectory default fullNameFor: (self application preferenceAt: #repositoryPath)! !

!WAMagmaSession methodsFor: 'as yet unclassified' stamp: 'brp 10/28/2005 12:52'!
root

	^ self magmaSession root
! !

!WAConfigurationEditor methodsFor: '*Magma seaside' stamp: 'brp 11/4/2005 11:52'!
renderMagmaLocationAttribute: anAttribute on: html

	| location |
	location := configuration valueForAttribute: anAttribute.

	html divNamed: 'location' with: [
		html table: [
			location isLocal
				ifTrue: [
					html tableRowWithLabel: 'path:' 
						column: [ html textInputOn: #path of: location ]
				]
				ifFalse: [
					html tableRowWithLabel: 'path:' 
						column: [ html textInputOn: #host of: location ].
					html tableRowWithLabel: 'port:' 
						column: [ html textInputWithValue: location port
								callback: [:v | location port: v asNumber] ]
				]
		]
	]! !

!WAConfigurationEditor methodsFor: '*Magma seaside' stamp: 'cmm 11/10/2005 21:37'!
visitMagmaLocationAttribute: anAttribute with: html

	| location |
	location := configuration valueForAttribute: anAttribute.

	html
		selectFromList: anAttribute options
		selected: location class
		callback: [:v]
		labels: [ :ea | ea name ]
		liveCallback:
			[ :item :h |
			configuration takeValue: item default forAttribute: anAttribute.
			self renderMagmaLocationAttribute: anAttribute on: h ].

	self renderMagmaLocationAttribute: anAttribute on: html.! !

WAConfigurationAttribute subclass: #WAMagmaLocationAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magma seaside'!

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 10:00'!
accept: aVisitor with: anObject

	^ aVisitor visitMagmaLocationAttribute: self with: anObject! !

!WAMagmaLocationAttribute methodsFor: 'as yet unclassified' stamp: 'brp 11/4/2005 12:13'!
options

	^ MagmaLocation subclasses! !
